'****************************************************************************************
'* muicache! toolkit v1.0
'* CollectData&XLSOutput.vbs - server-side WSH script
'* Authors: Mirko Iodice (mirko at notageek.it), Luca Alberti
'* More info: http://www.notageek.it/muicache-toolkit.html
'****************************************************************************************


' ********** Global Declarations **********

Option Explicit

Dim DBCon	' Connection Object for database connectivity
Dim tblComputersRS, tblUsersRS, tblRelRS, tblMuiRS, tmpRS, XLSRS, tblXMLFilesRS	'Recordset Objects for database connectivity
Dim iCursorType, iLockType	'Cursor-Lock objects and Vars
iCursorType = 1
iLockType = 3
Dim sDBName, sProvider, sTableName, sRSName, sUsername, sComputername, sXMLName	'String vars
Dim sPath, sDescription, sVersion, sHash, sMuiID, sUserID, sComputerID, sXMLID, sSQL, sSQLTmpXLS	'String vars
Dim ScriptFile, CurrentPath, XLSFile, sExclusion, SProc	'String vars
Dim bVerbose, bLowDownCPU	'boolean vars
Dim dExecutionDate	'Date var
Dim objFSO, objFolder, objFile, xmlDoc, ObjMui, ObjAtt, objNode, objExclude, objWMI, objProc	'Other objects
Dim ColFiles, ColNodes, ColProcs	'Collections
Dim i	'counters

' ********** Global Declarations End **********


' ********** Only for Windows 2000 wich does not support Win32_Process CommandLine **********
'
' -	leave bLowDownCPU to 0 (default) to maximize the script execution speed but keep in
' 	mind that depending on your hardware the cpu usage for this script can reach 100%
'
' -	set bLowDownCPU to 1 to slow down the script and avoid CPU leakage
'
bLowDownCPU = 0

' ********** Only for Windows 2000 wich does not support Win32_Process CommandLine **********


'********** Beginning of Script engine check **********

If Not IsWin2000 Then
	bLowDownCPU = 0
	If LCase(Right(WScript.FullName, 11)) = "cscript.exe" Then
		bVerbose = 1
		sProc = "cscript.exe"
		Set objWMI = GetObject("winmgmts:\\.\root\cimv2")
		Set ColProcs = objWMI.ExecQuery("SELECT * FROM Win32_Process " & "WHERE Name='" & sProc & "'")
		For Each objProc in ColProcs
			If (InStr(LCase(objProc.CommandLine), LCase(WScript.ScriptName)) > 0) Then
				objProc.SetPriority 64 'Low Priority
			End If
		Next
		Set objWMI = Nothing
	Else
		bVerbose = 0
		sProc = "wscript.exe"
		Set objWMI = GetObject("winmgmts:\\.\root\cimv2")
		Set ColProcs = objWMI.ExecQuery("SELECT * FROM Win32_Process " & "WHERE Name='" & sProc & "'")
		For Each objProc in ColProcs
			If (InStr(LCase(objProc.CommandLine), LCase(WScript.ScriptName)) > 0) Then
				objProc.SetPriority 64 'Low Priority
			End If
		Next
		Set objWMI = Nothing
	End If
Else
	If LCase(Right(WScript.FullName, 11)) = "cscript.exe" Then
		bVerbose = 1
	Else
		bVerbose = 0
	End If	
End If

'********** End of Script engine check **********


'********** Beginning of Main Code **********

Call subDBConOpen ("muicache.mdb", "Microsoft.Jet.OLEDB.4.0")    'Open DB Connection

Set objFSO = CreateObject("Scripting.FileSystemObject")
ScriptFile = WScript.ScriptFullName    'get script full file name
CurrentPath = Left(ScriptFile, InstrRev(ScriptFile, "\")-1)    'get current directory
Set objFolder = objFSO.GetFolder(CurrentPath)
Set colFiles = objFolder.Files

For Each objFile in colFiles
	If UCase(objFSO.GetExtensionName(objFile.Path)) = "XML" Then
		'log info start
		If bVerbose = 1 Then
			wscript.echo "Importing data from " & objfile.name & " ..."
		End If
		'log info end
		Set xmlDoc = CreateObject("Microsoft.XMLDOM")
		xmlDoc.Async = "False"
		xmlDoc.Load(currentpath & "\" & objfile.name)
		Set ObjMui = xmlDoc.getElementsByTagName("muiset")
		For Each ObjAtt in ObjMui
			sUsername = trim(objatt.Attributes.getNamedItem("User").Text)
			sComputerName = trim(objatt.Attributes.getNamedItem("Pc").Text)
			dExecutionDate = trim(objatt.Attributes.getNamedItem("ExecutionDate").Text)
		Next
		sXMLName = trim(objfile.name)
		Set colNodes = xmlDoc.selectNodes("/muiset/*")
		For Each objNode in colNodes
			sPath = trim(objNode.Attributes.getNamedItem("Path").Text)
			sDescription = trim(objNode.Attributes.getNamedItem("Description").Text)
			sVersion = trim(objNode.Attributes.getNamedItem("Version").Text)
			shash = trim(objNode.Attributes.getNamedItem("Hash").Text)
			Call subXMLFilesOpen    'Open XMLFiles Table Recordset
			Call subComputersOpen    'Open Computers Table Recordset
			Call subUsersOpen    'Open Users Table Recordset
			Call subMuiOpen    'Open Mui Table Recordset
			Call subRelOpen    'Open Relationships Table Recordset
			Call subPopulateDB(sUsername, sComputername, sPath, sDescription, sVersion, shash, sXMLName, dExecutionDate)    'Data to DB
			Call subXMLFilesClose	'Close XMLFiles Table Recordset
			Call subComputersClose    'Close Computers Table Recordset
			Call subUsersClose    'Close Users Table Recordset
			Call subMuiClose    'Close Mui Table Recordset
			Call subRelClose    'Close Relationships Table Recordset
		Next
	End If
	Set XmlDoc = Nothing
Next
Call subCreateXLSFile 'Create XLS report
Call subDBConClose    'Close DB Connection
Set objFSO = nothing

WSCRIPT.QUIT

'********** End of Main Code **********


'********** Beginning of Sub routine to Open Database Connection **********
'
Sub subDBConOpen (sDBName, sProvider)
	Set DBCon = CreateObject("ADODB.Connection")
	DBCon.Provider = sProvider
	DBCon.Properties("Data Source") = sDBName
	DBCon.Open
End Sub

'********** End of sub routine to Open Database Connection **********


'********** Beginning of Sub routine to Close Database Connection **********
'
Sub subDBConClose
	DBCon.Close
	set DBCon = Nothing
End Sub

'********** End of sub routine to Close Database Connection **********


'********** Beginning of Sub routine to Open XMLFiles Table **********

Sub subXMLFilesOpen
	Set tblXMLFilesRS = CreateObject("ADODB.Recordset")
	tblXMLFilesRS.CursorType = iCursorType
	tblXMLFilesRS.LockType = iLockType
	tblXMLFilesRS.Source = "xmlfiles"
	tblXMLFilesRS.ActiveConnection = DBCon
	tblXMLFilesRS.Open
End Sub

'********** End of sub routine to Open XMLFiles Table **********


'********** Beginning of Sub routine to Open computers Table **********

Sub subComputersOpen
	Set tblComputersRS = CreateObject("ADODB.Recordset")
	tblComputersRS.CursorType = iCursorType
	tblComputersRS.LockType = iLockType
	tblComputersRS.Source = "computers"
	tblComputersRS.ActiveConnection = DBCon
	tblComputersRS.Open
End Sub

'********** End of sub routine to Open computers Table **********


'********** Beginning of Sub routine to Open users Table **********

Sub subUsersOpen
	Set tblUsersRS = CreateObject("ADODB.Recordset")
	tblUsersRS.CursorType = iCursorType
	tblUsersRS.LockType = iLockType
	tblUsersRS.Source = "users"
	tblUsersRS.ActiveConnection = DBCon
	tblUsersRS.Open
End Sub

'********** End of sub routine to Open users Table **********


'********** Beginning of Sub routine to Open muicache_entries Table **********

Sub subMuiOpen
	Set tblMuiRS = CreateObject("ADODB.Recordset")
	tblMuiRS.CursorType = iCursorType
	tblMuiRS.LockType = iLockType
	tblMuiRS.Source = "muicache_entries"
	tblMuiRS.ActiveConnection = DBCon
	tblMuiRS.Open
End Sub

'********** End of sub routine to Open muicache_entries Table **********


'********** Beginning of Sub routine to Open relationships Table **********

Sub subRelOpen
	Set tblRelRS = CreateObject("ADODB.Recordset")
	tblRelRS.CursorType = iCursorType
	tblRelRS.LockType = iLockType
	tblRelRS.Source = "relationships"
	tblRelRS.ActiveConnection = DBCon
	tblRelRS.Open
End Sub

'********** End of sub routine to Open relationships Table **********


'********** Beginning of Sub routine to Close XMLFiles Table **********

Sub subXMLFilesClose
	Set tblXMLFilesRS = Nothing
End Sub

'********** End of Sub routine to Close XMLFiles Table **********


'********** Beginning of Sub routine to Close computers Table **********

Sub subComputersClose
	Set tblComputersRS = Nothing
End Sub

'********** End of Sub routine to Close computers Table **********


'********** Beginning of Sub routine to Close users Table **********

Sub subUsersClose
	Set tblUsersRS = Nothing
End Sub

'********** End of Sub routine to Close ComputerList Table **********


'********** Beginning of Sub routine to Close muicache_entries Table **********

Sub subMuiClose
	Set tblMuiRS = Nothing
End Sub

'********** End of Sub routine to Close muicache_entries Table **********


'********** Beginning of Sub routine to Close relationships Table **********

Sub subRelClose
	Set tblRelRS = Nothing
End Sub

'********** End of Sub routine to Close relationships Table **********


'********** Beginning of Sub routine to Populate DB **********

Sub subPopulateDB(sUsername, sComputerName, sPath, sDescription, sVersion, shash, sXMLName, dExecutionDate)
	sSQL="SELECT xmlfiles.* FROM xmlfiles WHERE (((xmlfiles.xmlname)=" & chr(34) & sXMLName & chr(34) & "));"
	set tmpRS=DBCon.execute(sSQL)
	If tmpRS.EOF and tmpRS.BOF then    'no records found... add a new one
		tblXMLFilesRS.Addnew
		tblXMLFilesRS("xmlname")=sXMLName
		tblXMLFilesRS("xmldate")=dExecutionDate
		tblXMLFilesRS.Update
		sXMLID=tblXMLFilesRS("xml_id")
	Else
		sXMLID=tmpRS("xml_id")
		sSQL="UPDATE xmlfiles SET [xmlfiles].[xmldate] = " & chr(34) & dExecutionDate & chr(34) & " WHERE (((xmlfiles.xml_id)=" & sXMLID & ") AND ((xmlfiles.xmlname)=" & chr(34) & sXMLName & chr(34) & "));"
		set tmpRS=DBCon.execute(sSQL)
	End If
	Set tmpRS = Nothing
	'low down cpu usage start
		If bLowDownCPU = 1 Then
			wscript.sleep 1
		End If
	'low down cpu usage end
	sSQL="SELECT computers.* FROM computers WHERE (((computers.computername)=" & chr(34) & sComputername & chr(34) & "));"
	set tmpRS=DBCon.execute(sSQL)
	If tmpRS.EOF and tmpRS.BOF then    'no records found... add a new one
		tblComputersRS.Addnew
		tblComputersRS("computername")=sComputername
		tblComputersRS.Update
		sComputerID=tblComputersRS("computer_id")
	Else
		sComputerID=tmpRS("computer_id")
	End If
	Set tmpRS = Nothing
	'low down cpu usage start
	If bLowDownCPU = 1 Then
		wscript.sleep 1
	End If
	'low down cpu usage end
	sSQL="SELECT users.* FROM users WHERE (((users.username)=" & chr(34) & sUsername & chr(34) & "));"
	set tmpRS=DBCon.execute(sSQL)
	If tmpRS.EOF and tmpRS.BOF then    'no records found... add a new one
		tblUsersRS.Addnew
		tblUsersRS("Username")=sUsername
		tblUsersRS.Update
		sUserID=tblUsersRS("user_id")
	else
		sUserID=tmpRS("user_id")
	End If
	Set tmpRS = Nothing
	'low down cpu usage start
	If bLowDownCPU = 1 Then
		wscript.sleep 1
	End If
	'low down cpu usage end
	sSQL="SELECT muicache_entries.* FROM muicache_entries WHERE ((([muicache_entries].[mui_name])=" & chr(34) & sPath & chr(34) & ") And (([muicache_entries].[mui_desc])=" & chr(34) & sDescription & chr(34) & ") And (([muicache_entries].[mui_version])=" & chr(34) & sVersion & chr(34) & ") And (([muicache_entries].[mui_hash])=" & chr(34) & sHash & chr(34) & "));"
	set tmpRS=DBCon.execute(sSQL)
	If tmpRS.EOF and tmpRS.BOF then    'no records found... add a new one
		tblMuiRS.Addnew
		tblMuiRS("mui_name")=sPath
		tblMuiRS("mui_desc")=sDescription
		tblMuiRS("mui_version")=sVersion
		tblMuiRS("mui_hash")=sHash
		tblMuiRS.Update
		sMuiID=tblMuiRS("mui_id")
	Else
		sMuiID=tmpRS("mui_id")
	End If
	Set tmpRS = Nothing
	'low down cpu usage start
	If bLowDownCPU = 1 Then
		wscript.sleep 1
	End If
	'low down cpu usage end
	sSQL="SELECT relationships.* FROM relationships WHERE (((relationships.mui_id)=" & sMuiID & ") AND ((relationships.user_id)=" & sUserID & ") AND ((relationships.computer_id)=" & sComputerID & ") AND ((relationships.xml_id)=" & sXMLID & "));"
	set tmpRS=DBCon.execute(sSQL)
	If tmpRS.EOF and tmpRS.BOF then    'no records found... add a new one
		tblRelRS.Addnew
		tblRelRS("mui_id")=sMuiID
		tblRelRS("user_id")=sUserID
		tblRelRS("computer_id")=sComputerID
		tblRelRS("xml_id")=sXMLID
		tblRelRS("first_detection")=dExecutionDate
		tblRelRS("last_detection")=dExecutionDate
		tblRelRS.Update
	Else
		sSQL="UPDATE relationships SET [relationships].[last_detection] = " & chr(34) & dExecutionDate & chr(34) & " WHERE (((relationships.mui_id)=" & sMuiID & ") AND ((relationships.user_id)=" & sUserID & ") AND ((relationships.computer_id)=" & sComputerID & ") AND ((relationships.xml_id)=" & sXMLID & "));"
		set tmpRS=DBCon.execute(sSQL)
	End If
	Set tmpRS = Nothing
	'low down cpu usage start
	If bLowDownCPU = 1 Then
		wscript.sleep 1
	End If
	'low down cpu usage end
End Sub

'********** End of Sub routine to Populate DB **********


'********** Beginning of Sub routine to Create XLS File **********

Sub SubCreateXLSFile
	'Delete previous XLS File if exists
	If objFSO.FileExists(".\muicache.xls") Then
		Set XLSFile = objFSO.GetFile(".\muicache.xls")
		XLSFile.Delete
	End If
	If objFSO.FileExists(".\exclusions.txt") Then
		If Not ISFileEmpty(".\exclusions.txt") Then
			'log info start
			If bVerbose = 1 Then
				wscript.echo "Generating XLS report using exclusions.txt as data filter ..."
			End If
			'log info end
			Set objExclude = objFSO.OpenTextFile(".\exclusions.txt")
			i = 0
			'Start of Safety Check
			sSQLTmpXLS = "SELECT Name FROM MSysObjects WHERE Type = 1 AND Name Like " & chr(34) & "%tmpXLS%" & chr(34) & ";"
			set tmpRS = DBCon.Execute(sSQLTmpXLS)
			Do until tmpRS.eof = True
    				DBCon.Execute("Drop Table " & tmpRS("Name") & ";")
    				tmpRS.MoveNext
			Loop
			Set tmpRS = Nothing
			'End of Safety Check
			sSQLTmpXLS = "SELECT computers.computername, users.username, muicache_entries.mui_name, muicache_entries.mui_desc, muicache_entries.mui_version, muicache_entries.mui_hash, relationships.first_detection, relationships.last_detection, xmlfiles.xmldate, xmlfiles.xmlname INTO tmpXLS FROM xmlfiles INNER JOIN (users INNER JOIN (muicache_entries INNER JOIN (computers INNER JOIN relationships ON computers.computer_id = relationships.computer_id) ON muicache_entries.mui_id = relationships.mui_id) ON users.user_id = relationships.user_id) ON xmlfiles.xml_id = relationships.xml_id;"
			DBCon.execute(sSQLTmpXLS)
			Do Until objExclude.AtEndOfStream
				sExclusion = Trim(objExclude.ReadLine)
				'low down cpu usage start
				If bLowDownCPU = 1 Then
					wscript.sleep 1
				End If
				'low down cpu usage end
				If i = 0 Then
					sSQLTmpXLS = "SELECT tmpXLS.computername, tmpXLS.username, tmpXLS.mui_name, tmpXLS.mui_desc, tmpXLS.mui_version, tmpXLS.mui_hash, tmpXLS.first_detection, tmpXLS.last_detection, tmpXLS.xmldate, tmpXLS.xmlname INTO tmpXLS" & i & " FROM tmpXLS WHERE (((tmpXLS.mui_name) Not Like " & chr(34) & "%" & sExclusion & "%" & chr(34) & ") AND ((tmpXLS.mui_desc) Not Like " & chr(34) & "%" & sExclusion & "%" & chr(34) & "));"
					DBCon.execute(sSQLTmpXLS)
					DBCon.Execute("Drop Table tmpXLS;")
				Else
					sSQLTmpXLS = "SELECT tmpXLS" & i-1 & ".computername, tmpXLS" & i-1 & ".username, tmpXLS" & i-1 & ".mui_name, tmpXLS" & i-1 & ".mui_desc, tmpXLS" & i-1 & ".mui_version, tmpXLS" & i-1 & ".mui_hash, tmpXLS" & i-1 & ".first_detection, tmpXLS" & i-1 & ".last_detection, tmpXLS" & i-1 & ".xmldate, tmpXLS" & i-1 & ".xmlname INTO tmpXLS" & i & " FROM tmpXLS" & i-1 & " WHERE (((tmpXLS" & i-1 & ".mui_name) Not Like " & chr(34) & "%" & sExclusion & "%" & chr(34) & ") AND ((tmpXLS" & i-1 & ".mui_desc) Not Like " & chr(34) & "%" & sExclusion & "%" & chr(34) & "));"
					DBCon.execute(sSQLTmpXLS)
					DBCon.execute("Drop Table tmpXLS" & i-1 & ";")
				End If
				i = i + 1
			Loop
			objExclude.Close
			sSQL = "SELECT tmpXLS" & i-1 & ".computername, tmpXLS" & i-1 & ".username, tmpXLS" & i-1 & ".mui_name, tmpXLS" & i-1 & ".mui_desc, tmpXLS" & i-1 & ".mui_version, tmpXLS" & i-1 & ".mui_hash, tmpXLS" & i-1 & ".first_detection, tmpXLS" & i-1 & ".last_detection, tmpXLS" & i-1 & ".xmldate, tmpXLS" & i-1 & ".xmlname INTO [Excel 8.0;Database=muicache.xls].muicache_entries FROM tmpXLS" & i-1 & ";"
			DBCon.execute(sSQL)
			DBCon.execute("Drop Table tmpXLS" & i-1 & ";")
		Else
			'log info start
			If bVerbose = 1 Then
				wscript.echo "Generating XLS report without filtering data... (exclusions.txt is empty)"
			End If
			'log info end
			sSQL="SELECT computers.computername, users.username, muicache_entries.mui_name, muicache_entries.mui_desc, muicache_entries.mui_version, muicache_entries.mui_hash, relationships.first_detection, relationships.last_detection, xmlfiles.xmldate AS last_xml_date, xmlfiles.xmlname INTO [Excel 8.0;Database=muicache.xls].muicache_entries FROM xmlfiles INNER JOIN (users INNER JOIN (muicache_entries INNER JOIN (computers INNER JOIN relationships ON computers.computer_id = relationships.computer_id) ON muicache_entries.mui_id = relationships.mui_id) ON users.user_id = relationships.user_id) ON xmlfiles.xml_id = relationships.xml_id;"
			DBCon.execute(sSQL)
		End If
	Else
		'log info start
		If bVerbose = 1 Then
			wscript.echo "Generating XLS report without filtering data... (exclusions.txt does not exist)"
		End If
		'log info end
		sSQL="SELECT computers.computername, users.username, muicache_entries.mui_name, muicache_entries.mui_desc, muicache_entries.mui_version, muicache_entries.mui_hash, relationships.first_detection, relationships.last_detection, xmlfiles.xmldate AS last_xml_date, xmlfiles.xmlname INTO [Excel 8.0;Database=muicache.xls].muicache_entries FROM xmlfiles INNER JOIN (users INNER JOIN (muicache_entries INNER JOIN (computers INNER JOIN relationships ON computers.computer_id = relationships.computer_id) ON muicache_entries.mui_id = relationships.mui_id) ON users.user_id = relationships.user_id) ON xmlfiles.xml_id = relationships.xml_id;"
		DBCon.execute(sSQL)
	End If
End Sub

'********** End of Sub routine to Create XLS File **********

'********** Beginning of function to check if file is empty **********

Function ISFileEmpty(strFile)
	Dim TmpObjFSO, TmpObjFile, TmpObjReadFile, TmpStrContents
	Set TmpObjFSO = CreateObject("Scripting.FileSystemObject")
	Set TmpObjFile = objFSO.GetFile(strFile)
	If TmpObjFile.Size > 0 Then
		Set TmpObjReadFile = TmpObjFSO.OpenTextFile(strFile, 1)
		TmpStrContents = Trim(TmpObjReadFile.ReadAll)
		TmpStrContents = Replace(TmpStrContents," ","",1,-1,1)
		TmpStrContents = Replace(TmpStrContents,vbCrLF,"",1,-1,1)
		If TmpStrContents = "" Then
			IsFileEmpty = True
		Else
			IsFileEmpty = False
		End If
	Else
		IsFileEmpty = True
	End If
	Set TmpObjFSO = nothing
End Function

'********** End of function to check if file is empty **********


'********** Beginning of function to check if OS is Win2000 **********

Function IsWin2000
	Dim TmpObjWMI, TmpObjOS, TmpColOSs
	IsWin2000 = False
	Set TmpObjWMI = GetObject("winmgmts:\\.\root\cimv2")
	Set TmpColOSs = TmpObjWMI.ExecQuery ("Select * from Win32_OperatingSystem")
	For Each TmpObjOS in TmpColOSs
		If (Instr(LCase(TmpObjOS.Caption), Lcase("2000")) > 0) Then
			IsWin2000 = True
		End If
	Next
	Set TmpObjWMI = Nothing
End Function

'********** End of function to check if OS is Win2000 **********